<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Request StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Request
 * @subpackage Structs
 */
class Request extends AbstractStructBase
{
    /**
     * The ParamsSeletorDestino
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfCommandParameter
     */
    public $ParamsSeletorDestino;
    /**
     * The Tabela
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Tabela
     */
    public $Tabela;
    /**
     * The UserAuth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserAuthentication
     */
    public $UserAuth;
    /**
     * Constructor method for Request
     * @uses Request::setParamsSeletorDestino()
     * @uses Request::setTabela()
     * @uses Request::setUserAuth()
     * @param \ArrayType\ArrayOfCommandParameter $paramsSeletorDestino
     * @param \StructType\Tabela $tabela
     * @param \StructType\UserAuthentication $userAuth
     */
    public function __construct(\ArrayType\ArrayOfCommandParameter $paramsSeletorDestino = null, \StructType\Tabela $tabela = null, \StructType\UserAuthentication $userAuth = null)
    {
        $this
            ->setParamsSeletorDestino($paramsSeletorDestino)
            ->setTabela($tabela)
            ->setUserAuth($userAuth);
    }
    /**
     * Get ParamsSeletorDestino value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfCommandParameter|null
     */
    public function getParamsSeletorDestino()
    {
        return isset($this->ParamsSeletorDestino) ? $this->ParamsSeletorDestino : null;
    }
    /**
     * Set ParamsSeletorDestino value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfCommandParameter $paramsSeletorDestino
     * @return \StructType\Request
     */
    public function setParamsSeletorDestino(\ArrayType\ArrayOfCommandParameter $paramsSeletorDestino = null)
    {
        if (is_null($paramsSeletorDestino) || (is_array($paramsSeletorDestino) && empty($paramsSeletorDestino))) {
            unset($this->ParamsSeletorDestino);
        } else {
            $this->ParamsSeletorDestino = $paramsSeletorDestino;
        }
        return $this;
    }
    /**
     * Get Tabela value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Tabela|null
     */
    public function getTabela()
    {
        return isset($this->Tabela) ? $this->Tabela : null;
    }
    /**
     * Set Tabela value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Tabela $tabela
     * @return \StructType\Request
     */
    public function setTabela(\StructType\Tabela $tabela = null)
    {
        if (is_null($tabela) || (is_array($tabela) && empty($tabela))) {
            unset($this->Tabela);
        } else {
            $this->Tabela = $tabela;
        }
        return $this;
    }
    /**
     * Get UserAuth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserAuthentication|null
     */
    public function getUserAuth()
    {
        return isset($this->UserAuth) ? $this->UserAuth : null;
    }
    /**
     * Set UserAuth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserAuthentication $userAuth
     * @return \StructType\Request
     */
    public function setUserAuth(\StructType\UserAuthentication $userAuth = null)
    {
        if (is_null($userAuth) || (is_array($userAuth) && empty($userAuth))) {
            unset($this->UserAuth);
        } else {
            $this->UserAuth = $userAuth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
